<template>

  <Head>
    <title>Dashboard - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <!-- chart sales 7 days -->
          <div class="col-md-8">
            <div v-if="hasAnyPermission(['dashboard.sales_chart'])" class="card border-0 rounded-3 shadow">
              <div class="card-header">
                <span class="fw-bold"><i class="fa fa-chart-bar me-2"></i> SALES CHART 7 DAYS</span>
              </div>
              <div class="card-body">
                <BarChart :chartData="chartSellWeek" :options="options" />
              </div>
            </div>
          </div>
          <!-- sales today & profits today -->
          <div class="col-md-4">
            <!-- sales today -->
            <div v-if="hasAnyPermission(['dashboard.sales_today'])" class="card border-0 rounded-3 shadow">
              <div class="card-header">
                <span class="fw-bold"><i class="fa fa-chart-line me-2"></i> SALES TODAY</span>
              </div>
              <div class="card-body">
                <!-- count sales -->
                <strong>{{ count_sales_today }}</strong> SALES
                <hr />
                <!-- sum sales -->
                <h5 class="fw-bold">Rp {{ formatPrice(sum_sales_today) }}</h5>
              </div>
            </div>

            <!-- profits today -->
            <div v-if="hasAnyPermission(['dashboard.profits_today'])"
              class="card border-0 rounded-3 shadow border-top-success">
              <div class="card-header">
                <span class="font-weight-bold"><i class="fa fa-chart-bar me-2"></i> PROFITS TODAY</span>
              </div>
              <div class="card-body">
                <h5 class="fw-bold">Rp {{ formatPrice(sum_profits_today) }}</h5>
              </div>
            </div>

          </div>
        </div>

        <div class="row">
          <!-- best selling products -->
          <div class="col-md-6">
            <div v-if="hasAnyPermission(['dashboard.best_selling_product'])" class="card border-0 rounded-3 shadow">
              <div class="card-header">
                <span class="font-weight-bold"><i class="fa fa-chart-pie me-2"></i> BEST SELLING PRODUCT</span>
              </div>
              <div class="card-body">
                <DoughnutChart :chartData="chartBestProduct" />
              </div>
            </div>
          </div>
          <!-- products stock -->
          <div class="col-md-6">
            <div v-if="hasAnyPermission(['dashboard.product_stock'])" class="card border-0 rounded-3 shadow">
              <div class="card-header">
                <span class="font-weight-bold"><i class="fa fa-shopping-cart me-2"></i> PRODUCT STOCK</span>
              </div>
              <div class="card-body">
                <div v-if="products_limit_stock.length > 0">
                  <ol class="list-group list-group-numbered">
                    <li v-for="product in products_limit_stock" :key="product.id"
                      lass="list-group-item d-flex justify-content-between align-items-start">
                      <div class="ms-2 me-auto">
                        <div class="card">
                          <div class="card-body">
                            <div class="fw-bold">{{ product.name }} <sup> <span class="badge bg-danger rounded-pill">{{ product.stock }}</span></sup></div>
                        <div class="text-muted"><small>Category: {{ product.category.name }}</small></div>
                          </div>
                        </div>
                      </div>
                    </li>
                  </ol>
                </div>
                <div v-else class="alert alert-danger border-0 shadow rounded-3">
                  No data product.
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import Head and useForm from inertia
import { Head } from '@inertiajs/vue3'

// import ref from vue
import { ref } from 'vue';

// chart
import { BarChart, DoughnutChart } from 'vue-chart-3'
import { Chart, registerables } from 'chart.js'

// register chart
Chart.register(...registerables)
export default {
  // layout
  layout: LayoutApp,

  // register components
  components: {
    Head,
    BarChart,
    DoughnutChart,
  },

  // props
  props: {
    // total penjualan hari ini
    count_sales_today: Number,

    // jumlah (Rp ) penjualan hari ini
    sum_sales_today: Number,

    // jumlah profits / laba hari ini
    sum_profits_today: Number,

    // chart sales
    sales_date: Array,
    grand_total: Array,

    // products terlaris
    product: Array,
    total: Array,

    // products limit stock
    products_limit_stock: Array,
  },

  setup(props) {
    // method random color
    function randomBackgroundColor(length) {
      var data = [];
      for (var i = 0; i < length; i++) {
        data.push(getRandomColor());
      }

      return data;
    }

    // method generate random color
    function getRandomColor() {
      var letters = '0123456789ABCDEF'.split('');
      var color = '#';
      for (var i = 0; i < 6; i++) {
        color += letters[Math.floor(Math.random() * 16)];
      }
      return color;
    }

    // options chart
    const options = ref({
      responsive: true,
      plugins: {
        legend: {
          display: false,
        },
        title: {
          display: false,
        },
      },
      beginZero: true,
    });

    // chart sell week
    const chartSellWeek = {
      labels: props.sales_date,
      datasets: [{
        data: props.grand_total,
        backgroundColor: randomBackgroundColor(props.sales_date.length),
      },],
    };

    // chart best products
    const chartBestProduct = {
      labels: props.product,
      datasets: [{
        data: props.total,
        backgroundColor: randomBackgroundColor(5),
      }]
    };

    // return
    return {
      options,
      chartSellWeek,
      chartBestProduct
    }
  }
}
</script>